;==============================================================
; Copyright 2002 Eelke Visser
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;==============================================================
;
; In deze file staan de Math routines.
; Voor keer en delen enzo....
;
;==============================================================

;==============================================================
; Deel a door b 
; In : HI LO , DIV=W2 
; Uit : RESLT LO, HI
; Lo = rest van deling
; RESLT = resultaat van de deling. (lo byte)
; HI = resultaat van de deling. (Hi byte)
;==============================================================
Deel:                           ; Deel het enen door het andere
        clrf RESLT              ; Resultaten ff op nul.
        clrf W1
Deelloop:
        movf W2,W               ; W = DIV
        subwf LO,F              ; LO = LO - W
        btfss STATUS,C          ; Is c gelijk aan nul dan negatief.
        goto Deelhi             ; Ja ga dus hi byte verwerken.
        goto Deelnext           ; nee pos


Deelhi:
        movlw H'01'             ; w = 1
        subwf HI,F              ; HI = hi - w
        btfss STATUS,C          ; Is C gelijk nul dan negatief
        goto Deelneg            ; ja negatief 
        goto Deelnext           ; nee pos

Deelnext:                       ; als pos dan  
        movlw H'01'             ; w = 1
        addwf RESLT,F             ; RES = RES + 1
        btfsc STATUS,C          ; carry ?
        incf W1,F               ; W1 ++
        goto Deelloop

Deelneg:
        movf W2,W               ; w = 10
        addwf LO,F
        movf W1,W               ; w = W1
        movwf HI                ; hi = w
        return

;==============================================================
; Laat de koers zien die op het display staan moet.
; uit : XXXX.X
; in : HI , LO
; 
;==============================================================
Valtostr:
	movlw H'05' 
       	movwf POINT


	
Valtostrloop:

;Nopoint:

; deel de bende door 10
        movlw H'0A'             ; w = D'10'
        movwf W2                ; w2 = W
        call Deel               ; Deel door 10


; if ((reslt =0) && (hi = 0) && (Lo = 0) && (point > C1)) then
;       printf(" ")
; else
;       printf(LO + "0");

        movf LO,W               ; W = LO
        btfss STATUS,Z          ; Is z = 1 dan LO = 0
        goto Nospace            ; LO <> 0 dus no space

        movf RESLT,W            ; W = RESLT
        btfss STATUS,Z          ; Is z = 1 dan RESLT = 0
        goto Nospace            ; RESLT <> 0 dus no space
 
        movf HI,W               ; W = HI
        btfss STATUS,Z          ; Is z = 1 dan HI = 0
        goto Nospace            ; HI <> 0 dus no space

    	movlw H'05'             ; w = C1
        subwf POINT,W           ; W = F - W 
        btfsc STATUS,C          ; Is c = 1 dan (point - 5 > 0)
        goto Nospace            ; > 0

        ;movlw H'20'              ; < 0  , W = char (' ') (SPACE)
	movfw POINT		; zet de pointer juist!
	addlw H'0B'
	movwf FSR
        movlw H'20'              ; < 0  , W = char (' ') (SPACE)

   	goto Savespace       ; print space !!!!!!

Nospace:
				; converteer naar char

Savechar:			;Lcdkoerssend:
	movfw POINT		; zet de pointer juist!
	addlw H'0B'
	movwf FSR

	movfw LO		; haal de byte op!	
        addlw H'30'              ; W = W + H'30'
Savespace
	movwf INDF
	clrf I2CBITCNT

	movlw H'07'			; for x = 0 to 7
	movwf I2CBYTE
	bcf STATUS,C
	rlf INDF,F		; doe keer 2
	
Savecharloop:
	rlf INDF,F
	btfsc STATUS,C	
	comf I2CBITCNT,F		; tell bits.
				; next x

	decfsz I2CBYTE,F
	goto Savecharloop
	
	rlf INDF,F
	
	btfss I2CBITCNT,0
	BSF STATUS,C
	rlf INDF,F

				; TO DO Sla het char opin de array!!!!


        movf RESLT,W            ; W=RES
        movwf LO                ; LO = W
        decf POINT,F            ; POINT--
        btfsc STATUS,Z          ; Is Nul dan alle 5 gedaan!
        return                  ; nee pos
        goto Valtostrloop       	; ja neg nog een rondje
;==============================================================
